(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: OBRKLAV.PAS                                                    *)
(*  Obsah: procedury pro zobrazeni klavesnice a vybarvovani jednotlivych   *)
(*         klaves podle scankodu                                           *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 21.6.2008                                             *)
(*  Pro kompilaci: VESA.TPU, KLAVESY.TPU                                   *)
(*  Pro spusteni: FONT5X5.FNT                                              *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program zobrazovac_klavesnice;
uses vesa,klavesy;

const zobrklx=30; zobrkly=170;  {levy horni roh zobrazovane klavesnice}
      posledni=16+21+21+16+17+10;
      index:byte=1; {index naposledy kreslene klavesy (vyrazne urychli vyhledavani nasledujicich scankodu)}

var klx,kly:array[1..posledni] of integer;
    kls,klv,sck:array[1..posledni] of byte;
    klt:array[1..posledni] of string[5];
    fnt:_font;
    f:file;

procedure ZobrazKlavesu(scankod,styl:word);
{Vykresli na klavesnici jednu klavesu.
 Scankod: MSb=1 => zbytek cisla znamena primo index v polich,
              0 => klavesa se hleda podle scankodu
 Styl: 0 = normalni sediva, 1 = zvyraznena zlute, 2 = zvyraznena fialove,
       3 = kombinace obou barev (srafovano)}
var odzacatku:boolean;{pro hledani indexu}
    lhb,pdb,vb:word;{barvy}
Begin
{nalezeni indexu:}
if scankod>$8000
  then index:=scankod and $00FF
  else begin
       odzacatku:=index=1;
       scankod:=scankod and $00FF;
        repeat
        while (index<=posledni)and(scankod<>sck[index]) do inc(index);
        if scankod=sck[index] then break;
        if (index>posledni)and odzacatku then exit {neexistujici scankod}
                                         else begin {projizdime znovu}
                                              odzacatku:=true;
                                              index:=1;
                                              end;
        until false; {ukoncuje se breakem nebo exitem}
       end;
{barvy:}
case styl of 0:begin lhb:=15; pdb:= 8; vb:= 7 shl 8 or  7; end;
             1:begin lhb:=14; pdb:= 6; vb:=43 shl 8 or 43; end;
             2:begin lhb:=13; pdb:=34; vb:=35 shl 8 or 35; end;
             3:begin lhb:=14; pdb:=34; vb:=43 shl 8 or 35; end;
             end;
{vykresleni:}
__maskedbox(zobrklx+klx[index],zobrkly+kly[index],zobrklx+klx[index]+kls[index]-1,zobrkly+kly[index]+klv[index]-1,
            lhb,pdb,vb,_sikmepruhy);
_print(zobrklx+klx[index]+3,zobrkly+kly[index]+5,0,klt[index]);
End;{zobrazklavesu}


procedure ZobrazKlavesnici;
{Vykresli celou klavesnici.}
const ns=23; nvr=ns+2; nv=20; nsr=22;
var i:byte;
Begin
{zakladni deska:}
_box(zobrklx-10,zobrkly-10,zobrklx+584,zobrkly+6*nsr+20,15,8,7);
{"vyrezy" okolo skupin klaves:}
_box(zobrklx-5,zobrkly+nsr+6,zobrklx+15*nvr-3,zobrkly+6*nsr+11,8,15,0);{alfanumericka cast}
_box(zobrklx+19*nvr-5,zobrkly+nsr+6,zobrklx+577,zobrkly+6*nsr+11,8,15,0);{numericka cast}
_box(zobrklx+15*nvr+5,zobrkly+4*nsr+6,zobrklx+18*nvr+12,zobrkly+6*nsr+11,8,15,0);{sipky}
_box(zobrklx+15*nvr+5,zobrkly+nsr+6,zobrklx+18*nvr+12,zobrkly+3*nsr+11,8,15,0);{klavesy nad sipkami}
_box(zobrklx-5,zobrkly-4,zobrklx+nvr+2,zobrkly+nsr+1,8,15,0);{esc}
_box(zobrklx+nvr+10,zobrkly-4,zobrklx+5*nvr+17,zobrkly+nsr+1,8,15,0);{F1..F4}
_box(zobrklx+6*nvr,zobrkly-4,zobrklx+10*nvr+7,zobrkly+nsr+1,8,15,0);{F5..F8}
_box(zobrklx+10*nvr+15,zobrkly-4,zobrklx+15*nvr-3,zobrkly+nsr+1,8,15,0);{F9..F12}
_box(zobrklx+15*nvr+5,zobrkly-4,zobrklx+18*nvr+12,zobrkly+nsr+1,8,15,0);{printscreen..break}
{kontrolky rozsvicene podle skutecneho stavu locku:}
_box(zobrklx+19*nvr-5,zobrkly-4,zobrklx+577,zobrkly+nsr+1,8,15,0);
_print(zobrklx+19*nvr+1,zobrkly,0,'NUM   CAPS  SCRL');
i:=10*ord(numlock) or 8;
_box(zobrklx+19*nvr+5,zobrkly+12,zobrklx+19*nvr+13,zobrkly+17,0,0,i);
i:=10*ord(capslock) or 8;
_box(zobrklx+19*nvr+5+38,zobrkly+12,zobrklx+19*nvr+13+38,zobrkly+17,0,0,i);
i:=10*ord(scrolllock) or 8;
_box(zobrklx+19*nvr+5+2*38,zobrkly+12,zobrklx+19*nvr+13+2*38,zobrkly+17,0,0,i);
{klavesy:}
for i:=1 to posledni do zobrazklavesu(i or $8000,0);
End;{zobrazklavesnici}

{testovaci program:}
BEGIN
{nacteni klavesnice:}
assign(f,'OBRKLAV.DAT');
reset(f,1);
blockread(f,klx,sizeof(klx));
blockread(f,kly,sizeof(kly));
blockread(f,kls,sizeof(kls));
blockread(f,klv,sizeof(klv));
blockread(f,klt,sizeof(klt));
blockread(f,sck,sizeof(sck));
close(f);
if ioresult<>0 then begin
                    writeln('Chybi soubor OBRKLAV.DAT nebo nejde precist.');
                    writeln('Spustte program GENERUJ, ten ho vytvori.');
                    writeln;
                    writeln('Konec libovolnou klavesou.');
                    krcr;
                    halt;
                    end;
{grafika a font:}
_setmode(_640x480);
_nactifont2(fnt,'FONT5X5.FNT');
_nastavfont(fnt,true);

{zobrazeni klavesnice:}
zobrazklavesnici;

_print(220,450,15,'Pokraujte libovolnou klvesou.');
krcr;

{ukazkove vybarveni nekolika klaves:}
zobrazklavesu(28,1);
zobrazklavesu(9,2);
zobrazklavesu(78,3);

_bar(0,440,_maxx,460,0);
_print(240,450,15,'Konec libovolnou klvesou.');
krcr;

{ukonceni:}
_zrusfont(fnt);
_setmode(0);
END.
